package org.codehaus.mojo.animal_sniffer;

/*
 * The MIT License
 *
 * Copyright (c) 2008 Kohsuke Kawaguchi and codehaus.org.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

import java.io.DataInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;

/**
 * @author Kohsuke Kawaguchi
 */
public class Main
    extends ClassFileVisitor
{
    public static void main( String[] args )
        throws IOException
    {
        if ( args.length == 0 )
        {
            System.err.println( "Usage: java -jar animal-sniffer.jar [JAR/CLASS FILES]" );
            System.exit( -1 );
        }

        Main m = new Main();
        for ( int i = 0; i < args.length; i++ )
        {
            m.process( new File( args[i] ) );
        }
    }

    protected void process( String name, InputStream image )
        throws IOException
    {
        DataInputStream dis = new DataInputStream( image );
        byte[] buf = new byte[8];
        dis.readFully( buf );

        System.out.println( u2( buf[6], buf[7] ) + "." + u2( buf[4], buf[5] ) + " " + name );
    }

    private static int u2( byte u, byte d )
    {
        return ( (int) u ) * 256 + d;
    }
}
